
import Bladex
import Menu
import GameText
import Scorer
import acts
import Language
import Raster
import ItemTypes
import darfuncs
import BUIx
import acts
import BBLib
import CharStats
import Sparks

try: import castlesetup
except: pass


GameText.MapList ['CASTLE'] = 'Castle'




def ToggleGodMode():

	player = Bladex.GetEntity("Player1")

	if (player.Life <= 0):
		print("playerlife = " + str(player.Life))
		return

	InvincOnText = "invincibility on"
	InvincOffText = "invincibility off"

	if (Language.Current == "German"):

		InvincOnText = "Unverwundbarkeit ein"
		InvincOffText = "Unverwundbarkeit aus"


	if (player.Data.Invincibility == 3):
		player.Data.Invincibility = 0
		GameText.WriteTextAux(InvincOffText,1,255,255,255,[])

	elif (player.Data.Invincibility == 0):

		player.Data.Invincibility = 3
		Bladex.GetEntity("Player1").ResetWounds()
		GameText.WriteTextAux(InvincOnText,1,255,0,0,[])
	else:
		
		player.Data.Invincibility = 0
		GameText.WriteTextAux(InvincOffText,1,255,255,255,[])





def Level_Up():

	player = Bladex.GetEntity("Player1") 
	if (player.Level < 19):

		player.Level = player.Level +1
		player.Life = CharStats.GetCharMaxLife(player.Kind,player.Level)
		Bladex.GetEntity("Player1").ResetWounds()



def Level_Down():

	player = Bladex.GetEntity("Player1") 
	if (player.Level > 0):

		player.Level = player.Level -1
		player.Life = CharStats.GetCharMaxLife(player.Kind,player.Level)
		Bladex.GetEntity("Player1").ResetWounds()



def CheckAndAssignKeys():


	try:
		import castlesetup
		PYFILEMISSING = 0

	except: 

		PYFILEMISSING = 1
		print("DefFuncs.py: castlesetup.py not existing or invalid content")


	if (PYFILEMISSING == 1):
	
		INVINCKEY = "G"
		LEVELUPKEY = "F10"
		LEVELDOWNKEY = "F9"

	else:
		global godmodekey
		global levelupkey
		global leveldownkey

		validgodmodekeys = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N",
					"O","P","Q","R","S","T","U","V","W","X","Y","Z"]

		validlevelkeys = ["F9","F10","A","B","C","D","E","F","G","H","I","J","K","L",
					"M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"]

		INVINCKEY = castlesetup.godmodekey
		LEVELUPKEY = castlesetup.levelupkey
		LEVELDOWNKEY = castlesetup.leveldownkey

		if (castlesetup.godmodekey in validgodmodekeys):

			Bladex.AddInputAction("ToggleGodMode", 0)
			Bladex.AddBoundFunc("ToggleGodMode",ToggleGodMode)
			Bladex.AssocKey("ToggleGodMode", "Keyboard", INVINCKEY, 1)
			# INVINCKEY = "G"

		if (castlesetup.levelupkey in validlevelkeys):
			
			Bladex.AddInputAction("Level_Up", 0)
			Bladex.AddBoundFunc("Level_Up",Level_Up)
			Bladex.AssocKey("Level_Up", "Keyboard", LEVELUPKEY, 1)
			# LEVELUPKEY = "F10"

		if not (castlesetup.leveldownkey in validlevelkeys):

			Bladex.AddInputAction("Level_Down", 0)
			Bladex.AddBoundFunc("Level_Down",Level_Down)
			Bladex.AssocKey("Level_Down", "Keyboard", LEVELDOWNKEY, 1)
			# LEVELDOWNKEY = "F9"



class CastleTravelBook(BUIx.B_RectWidget):
	def __init__(self,Parent,Menudesc,StackMenu,VertPos=0):
		self.index = 1
		self.images = []
		self.vidw = 1
		self.vidh = 1
		char = Bladex.GetEntity("Player1")
		Raster.UnifyRenderBuffers()
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillaspecials.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillaweapons.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current + "\\" + char.Kind + "\\plantillahabilities.jpg")
		self.AddImage("..\\..\\Data\\TB\\" + Language.Current +"\\Items\\plantillaGitems.jpg")
		self.AddImage("..\\..\\Maps\\Castle\\castle.jpg")
		# self.AddImage("..\\..\\Maps\\Castle\\credits.jpg")
		BUIx.B_RectWidget.__init__(self,Parent,Menudesc["Name"],self.vidw,self.vidh)
		self.Selected=0
		self.Solid=0
		self.Border=0
		self.SetDrawFunc(self.Draw)
		self.SndCorreGema=Bladex.CreateSound("..\\..\\Sounds\\golpe-2.wav","Chanje")
		self.SndCorreGema.Volume=0.5
		self.SndCorreGema.MinDistance=1000000.0
		self.SndCorreGema.MaxDistance=2000000

	def AddImage(self, file):
		image = BBLib.B_BitMap24()
		image.ReadFromFile(file)
		self.images.append(image)

	def Draw(self,x,y,time):

		char = Bladex.GetEntity("Player1")
		x,y = Raster.GetSize()
		Raster.SetPosition((x - 640)/2, (y - 480)/2)
		if self.index < 0:
			self.index = len(self.images) - 1
		if self.index > len(self.images) - 1:
			self.index = 0
		Raster.DrawImage(640,480,"BGR","Normal",self.images[self.index].GetData())
		self.DefDraw(x,y,time)

	def FinalRelease(self):
		BUIx.B_RectWidget.FinalRelease(self)

	def AcceptsFocus(self):
		return 1

	def IncMenuItem(self):
		# self.SndCorreGema.PlayStereo()
		self.index = self.index + 1

	def DecMenuItem(self):
		# self.SndCorreGema.PlayStereo()
		self.index = self.index - 1

	def GetFocus(self):
	    return self

	def ActivateItem(self,activate):
		Menu.ActivateMenu()


def ExecTravelBook():

	GameText.AbortText()
	if not Menu.MENU_PREACTIVATED:
		try:
			Menu.TB_ACTIVATED=1
		except:
			pass
		Menu.MENU_PREACTIVATED = 1
		pepote = Menu.Desc1
		Menu.Desc1={"Name":"TopMenu","FrameKind":CastleTravelBook,"ListDescr":[{"Name":"Back","Kind":CastleTravelBook}]}
		Menu.ActivateMenu()
		Menu.Desc1 = pepote
		Scorer.HideTBS()
		for kn in acts.GetKeyList("Turn Left"):
			if kn!="Left":
				Bladex.AssocKey("Menu Dec","Keyboard",kn)
		for kn in acts.GetKeyList("Turn Right"):
			if kn!="Right":
				Bladex.AssocKey("Menu Inc","Keyboard",kn)

def TravelBookKey():

	Bladex.AddBoundFunc("LaunchTravel",ExecTravelBook)
	Bladex.RemoveBoundFunc("LaunchTravel",acts.ExecTravelBookNP)





def AssignCastleKeys():

	TravelBookKey()
	CheckAndAssignKeys()


AssignCastleKeys()